<?php

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("datahandler_user_insert", "dispname_newuser");
$plugins->add_hook("datahandler_user_update", "dispname_updateuser");
$plugins->add_hook("datahandler_user_validate", "dispname_verifyloginname");

$plugins->add_hook('admin_users_do_add', 'dispname_admin_do_newuser');
$plugins->add_hook('admin_users_do_edit', 'dispname_admin_do_edituse');
//$plugins->add_hook('admin_users_do_do_merge', 'dispname_admin_do_merge');


function dispname_info()
{
	return array(
		"name"			=> "Display Name",
		"description"	=> "Allow users to have a different display name to their login name.",
		"website"		=> "http://endlessparadigm.com",
		"author"		=> "ZiNgA BuRgA",
		"authorsite"	=> "http://zingaburga.com",
		"version"		=> "1.0",
	);
}

function dispname_activate()
{
	global $db;
	$db->query("ALTER TABLE `".TABLE_PREFIX."users` ADD `loginname` varchar(120) NOT NULL default ''");
	$db->query("UPDATE `".TABLE_PREFIX."users` SET loginname=username");
}

function dispname_deactivate()
{
	global $db;
	$db->query("ALTER TABLE `".TABLE_PREFIX."users` DROP `loginname`");
}

function dispname_newuser(&$uh)
{
	global $db;
	if(isset($uh->data['loginname']))
		$uh->user_insert_data['loginname'] = $db->escape_string($uh->data['loginname']);
	else
		$uh->user_insert_data['loginname'] = $uh->user_insert_data['username'];
}

function dispname_updateuser(&$uh)
{
	global $db;
	if(isset($uh->data['loginname']))
		$uh->user_update_data['loginname'] = $db->escape_string($uh->data['loginname']);
	else
		$uh->user_update_data['loginname'] = $db->escape_string($uh->data['username']);
}

function dispname_admin_do_newuser()
{
	global $user, $mybb;
	if($mybb->input['loginname'] != '')
		$user['loginname'] = $mybb->input['loginname'];
	else
		$user['loginname'] = $mybb->input['username'];
}

function dispname_admin_do_edituse()
{
	global $user, $mybb;
	if($mybb->input['loginname'] != '')
		$user['loginname'] = $mybb->input['loginname'];
	//else
	//	$user['loginname'] = $mybb->input['username'];
}

function dispname_verifyloginname(&$uh)
{
	// if a username exists error is there, remove it
	foreach(array_keys($uh->errors) as $k)
	{
		if($uh->errors[$k]['error_code'] == 'username_exists')
		{
			unset($uh->errors[$k]);
			break;
		}
	}
	
	verify_loginname_exists($uh);
}

// copied from MyBB's userhandler
function verify_loginname_exists(&$uh)
{
	global $db;

	$username = $uh->data['loginname'];
	if(!$username) $username = $uh->data['username'];

	$query = $db->simple_select(TABLE_PREFIX."users", "COUNT(uid) AS count", "LOWER(loginname)='".$db->escape_string(strtolower(trim($username)))."' AND uid!='{$uh->data['uid']}'");
	$user_count = $db->fetch_field($query, "count");
	if($user_count > 0)
	{
		$uh->set_error("username_exists", array($username));
		return true;
	}
	else
	{
		return false;
	}
}

?>
